#!/usr/bin/perl
# read database
open(DATA, "data") || die "Could't open data file";
while(<DATA>){
   /^\*name:/ && do { split ; $name = $_[1] ; next };
   /^\*phone:/ && do { split ; $phone{$name} = $_[1] ; next };
};
close DATA;
# report the result
@name = sort keys(%phone);   # build sorted keys list
print $#name+1, " entries read:\n";
foreach $name (@name) {
   printf "%-18s, phone number: %4s\n" , $name , $phone{$name};
};
# return a formated date
sub asctime {
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                                  localtime(time);
   $asctime = sprintf("%3s %3s %2d %2d:%2d:%2d %4d",
         (Sun,Mon,Tue,Wed,Thu,Fri,Sat)[$wday],
         (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$mon],
         $mday, $hour, $min, $sec, 1900+$year);
}
# etablish an interrupt handler for ^C
$ppid = $$;   # parrent pid
$SIG{'INT'} = 'ended';   # interrupt handler
sub ended {   # handle ^C at keyboad
   if($$ == $ppid){   # only in the parrent
      print "\n", &asctime,
            " : Stopping after ", $connexion-1, " connexions\n";
      ($usr, $sys) = times;
      printf "Cpu: (%6.2fusr, %6.2fsys)\n", $usr, $sys;
      exit;
   }
}
# prepare socket stuff (p.344)
($port) = @ARGV;
$port = 2345 unless $port;
$AF_INET = 2;
$SOCK_STREAM = 1;
$sockaddr = 'S n a4 x8';
($name, $aliases, $proto) = getprotobyname('tcp');
$this = pack($sockaddr, $AF_INET, $port, "\0\0\0\0");
socket(S, $AF_INET, $SOCK_STREAM, $proto) || die "socket: $!";
$on = pack('I', 1);   # set socket to reuse address
$SOL_SOCKET = 0xffff;
$SO_REUSEADDR = 0x0004;
setsockopt(S, $SOL_SOCKET, $SO_REUSEADDR, $on);
bind(S,$this) || die "bind: $!";
listen(S,5) || die "listen : $!";
$connexion = 0;      # connexions number
# all is ready, loop on connexions
for(;;) {
   $connexion++;
   ($addr = accept(NS,S)) || die "accept: $!";
   if( fork() == 0) {   # in the child
      select(NS); $| = 1; select(stdout);   # set "hot pipes"
      ($af, $port, $inetaddr) = unpack($sockaddr, $addr);
      @inetaddr = unpack('C4', $inetaddr);
      print &asctime ,
       " : Connexion $connexion: ",
       "From @inetaddr, port $port starting\n";
      $query = 0;   # queries number
      print NS
        "Welcome to this small perl program. Enter q to quit\n> ";
      while (<NS>) {   # try to answer queries
                                          # cleanup and lowercase
         $_ =~ tr/[ \t\r\n]//d ;$_ =~ tr/A-Z/a-z/;
         last if ( $_ eq "q" );         # quit ?
         $query++;
         print NS $_ ,
                " : " , $phone{$_} ? $phone{$_} : "unknown" , "\n>";
      }
      print NS $query , " queries, Goodbye...\n";   # game over...
      print &asctime ,
           " : Connexion $connexion: ended after $query queries\n";
      exit;
   }
   close(NS);      # in the parent: goto 1
}

