#!/usr/bin/perl
@a = ('1.2.3.4',
      '20.2.3.4',
      '11.2.3.4',
      '10.2.3.4',
      '100.2.3.4');         # the list to sort
pipe( RE1, WR1);            # pipe to sort
pipe( RE2, WR2);            # pipe from sort
if ( fork() == 0 ){         # in the child
   close(STDIN);            # close STDIN
   open(STDIN, "<&RE1");    # duplicate RE1 on STDIN
   close(RE1);              # close RE1
   close(WR1);              # and WR1
   close(STDOUT);           # close STDOUT
   open(STDOUT, ">&WR2");   # duplicate WR2 on STDOUT
   close(WR2);              # close WR2
   close(RE2);              # and RE2
                            # now STDIN is RE1 and STDOUT is WR2
                            # sort will read RE1, write WR2
   exec("sort -t. -n");    # do it!
#   exec("sort -t. +0 -1n +1 -2n +2 -3n +3 -4");    # do it!
} else {                    # in the parent
   close(WR2);              # close WR2
   close(RE1);              # close RE1
   foreach $a (@a) {        # write the list on WR1
      print WR1 "$a\n";
   }
   close(WR1);              # close WR1, this will start sort!
   while(<RE2>) {           # read result on RE2
      print "$_";           # and print it
   }
}
__END__

1.2.3.4
10.2.3.4
11.2.3.4
20.2.3.4
100.2.3.4

