#!/usr/bin/perl

$nsol=0;
%grid={};

sub read_grid {
  my ( $file ) = @_;
  open( F, $file ) || die("open");
  for($l=0;$l<9;$l++){
    $line=<F>;
    for($c=0;$c<9;$c++){
      $grid{ $l, $c } = substr($line,$c,1);
    }
  }
}

sub print_one {
  $nsol++;
  print "solution $nsol:\n";
  for($l=0;$l<9;$l++){
    for($c=0;$c<9;$c++){
      print " ",$grid{ $l, $c };
    }
    print "\n";
  }
}

sub test{
  my ($i, $j, $n ) = @_;
  if($grid{$i,$j} eq $n){return 1;}
  if($grid{$i,$j} ne "-"){return 0;}
  for(my $c=0;$c<9;$c++){
    if($grid{$i,$c} eq $n){return 0;}
  }
  for(my $l=0;$l<9;$l++){
    if($grid{$l,$j} eq $n){return 0;}
  }
  my $bl=int($i/3);
  my $bc=int($j/3);
  for(my $l=3*$bl;$l<3*($bl+1);$l++){
    for(my $c=3*$bc;$c<3*($bc+1);$c++){
      if($grid{$l,$c} eq $n){return 0;}
    }
  }
  return 1;
}

sub solve{
  my ( $l, $c ) = @_;
  if($l == 9){
    &print_one();
  }else{
    for(my $n=1;$n<10;$n++){
#    for($n=1;$n<10;$n++){
      if(&test($l,$c,$n)){
#        $t=$grid{$l,$c};
        my $t=$grid{$l,$c};
        $grid{$l,$c}=$n;
        if($c == 8){
          &solve($l+1,0);
        }else{
          &solve($l,$c+1);
        }
        $grid{$l,$c}=$t;
      }
    }
  }
}


if($#ARGV != 0){
  print "usage: $0 grid_file\n";
  exit(-1);
}
&read_grid($ARGV[0]);
&solve(0,0);
